(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports) :
	typeof define === 'function' && define.amd ? define(['exports'], factory) :
	(factory((global.casl = global.casl || {}, global.casl.query = {})));
}(this, (function (exports) { 'use strict';

function rulesToQuery(rules, convert) {
  var query = {};
  var ignoreOperators = {};

  for (var i = 0; i < rules.length; i++) {
    var rule = rules[i];
    var op = rule.inverted ? '$and' : '$or';

    if (!rule.conditions) {
      if (rule.inverted) {
        return null;
      }

      if (query[op]) {
        delete query[op];
      }

      ignoreOperators[op] = true;
    } else if (!ignoreOperators.hasOwnProperty(op)) {
      query[op] = query[op] || [];
      query[op].push(convert(rule));
    }
  }

  return rules.length > 0 ? query : null;
}

exports.rulesToQuery = rulesToQuery;

Object.defineProperty(exports, '__esModule', { value: true });

})));
